Index: i386/ibcs2/ibcs2_xenix.c
===================================================================
RCS file: /home/ncvs/src/sys/i386/ibcs2/ibcs2_xenix.c,v
retrieving revision 1.28
diff -u -r1.28 ibcs2_xenix.c
--- i386/ibcs2/ibcs2_xenix.c	23 Sep 2002 18:54:31 -0000	1.28
+++ i386/ibcs2/ibcs2_xenix.c	12 Dec 2002 03:14:38 -0000
@@ -79,12 +79,12 @@
 	caddr_t sg = stackgap_init();
 
 	DPRINTF(("IBCS2: 'xenix rdchk'\n"));
-	SCARG(&sa, fd) = SCARG(uap, fd);
-	SCARG(&sa, com) = FIONREAD;
-	SCARG(&sa, data) = stackgap_alloc(&sg, sizeof(int));
+	sa.fd = uap->fd;
+	sa.com = FIONREAD;
+	sa.data = stackgap_alloc(&sg, sizeof(int));
 	if ((error = ioctl(td, &sa)) != 0)
 		return error;
-	td->td_retval[0] = (*((int*)SCARG(&sa, data))) ? 1 : 0;
+	td->td_retval[0] = (*((int*)sa.data)) ? 1 : 0;
 	return 0;
 }
 
@@ -96,9 +96,9 @@
 	struct ftruncate_args sa;
 
 	DPRINTF(("IBCS2: 'xenix chsize'\n"));
-	SCARG(&sa, fd) = SCARG(uap, fd);
-	SCARG(&sa, pad) = 0;
-	SCARG(&sa, length) = SCARG(uap, size);
+	sa.fd = uap->fd;
+	sa.pad = 0;
+	sa.length = uap->size;
 	return ftruncate(td, &sa);
 }
 
@@ -123,7 +123,7 @@
 	itb.timezone = tz.tz_minuteswest;
 	itb.dstflag = tz.tz_dsttime != DST_NONE;
 
-	return copyout((caddr_t)&itb, (caddr_t)SCARG(uap, tp),
+	return copyout((caddr_t)&itb, (caddr_t)uap->tp,
 		       sizeof(struct ibcs2_timeb));
 }
 
@@ -132,8 +132,8 @@
 {
 	long period;
 
-	DPRINTF(("IBCS2: 'xenix nap %d ms'\n", SCARG(uap, millisec)));
-	period = (long)SCARG(uap, millisec) / (1000/hz);
+	DPRINTF(("IBCS2: 'xenix nap %d ms'\n", uap->millisec));
+	period = (long)uap->millisec / (1000/hz);
 	if (period)
 		while (tsleep(&period, PPAUSE, "nap", period) 
 		       != EWOULDBLOCK) ;
@@ -200,22 +200,22 @@
         int error, flags;
 	caddr_t sg = stackgap_init();
 
-	CHECKALTEXIST(td, &sg, SCARG(uap, path));
+	CHECKALTEXIST(td, &sg, uap->path);
 
         NDINIT(&nd, LOOKUP, FOLLOW | LOCKLEAF, UIO_USERSPACE,
-            SCARG(uap, path), td);
+            uap->path, td);
         if ((error = namei(&nd)) != 0)
                 return error;
         vp = nd.ni_vp;
 
         /* Flags == 0 means only check for existence. */
-        if (SCARG(uap, flags)) {
+        if (uap->flags) {
                 flags = 0;
-                if (SCARG(uap, flags) & IBCS2_R_OK)
+                if (uap->flags & IBCS2_R_OK)
                         flags |= VREAD;
-                if (SCARG(uap, flags) & IBCS2_W_OK)
+                if (uap->flags & IBCS2_W_OK)
                         flags |= VWRITE;
-                if (SCARG(uap, flags) & IBCS2_X_OK)
+                if (uap->flags & IBCS2_X_OK)
                         flags |= VEXEC;
                 if ((flags & VWRITE) == 0 || (error = vn_writechk(vp)) == 0)
                         error = VOP_ACCESS(vp, flags, cred, td);
Index: i386/svr4/svr4_machdep.c
===================================================================
RCS file: /home/ncvs/src/sys/i386/svr4/svr4_machdep.c,v
retrieving revision 1.26
diff -u -r1.26 svr4_machdep.c
--- i386/svr4/svr4_machdep.c	4 Apr 2002 17:49:46 -0000	1.26
+++ i386/svr4/svr4_machdep.c	12 Dec 2002 03:14:38 -0000
@@ -535,7 +535,7 @@
 			struct svr4_ssd ssd;
 			union descriptor bsd;
 
-			if ((error = copyin(SCARG(uap, a1), &ssd,
+			if ((error = copyin(uap->a1, &ssd,
 					    sizeof(ssd))) != 0) {
 				printf("Cannot copy arg1\n");
 				return error;
@@ -580,8 +580,8 @@
 				return error;
 			}
 
-			SCARG(&ua, op) = I386_SET_LDT;
-			SCARG(&ua, parms) = (char *) sap;
+			ua.op = I386_SET_LDT;
+			ua.parms = (char *) sap;
 
 			if ((error = copyout(&bsd, sa.desc, sizeof(bsd))) != 0) {
 				printf("Cannot copyout desc\n");
Index: ia64/ia32/ia32_misc.c
===================================================================
RCS file: /home/ncvs/src/sys/ia64/ia32/ia32_misc.c,v
retrieving revision 1.2
diff -u -r1.2 ia32_misc.c
--- ia64/ia32/ia32_misc.c	9 Oct 2002 22:27:24 -0000	1.2
+++ ia64/ia32/ia32_misc.c	12 Dec 2002 03:14:38 -0000
@@ -237,11 +237,11 @@
 	struct rusage32 *rusage32, ru32;
 	struct rusage *rusage = NULL, ru;
 
-	rusage32 = SCARG(uap, rusage);
+	rusage32 = uap->rusage;
 	if (rusage32) {
 		sg = stackgap_init();
 		rusage = stackgap_alloc(&sg, sizeof(struct rusage));
-		SCARG(uap, rusage) = (struct rusage32 *)rusage;
+		uap->rusage = (struct rusage32 *)rusage;
 	}
 	error = wait4(td, (struct wait_args *)uap);
 	if (error)
@@ -304,13 +304,13 @@
 	struct statfs *sp = NULL, stat;
 	int maxcount, count, i;
 
-	sp32 = SCARG(uap, buf);
-	maxcount = SCARG(uap, bufsize) / sizeof(struct statfs32);
+	sp32 = uap->buf;
+	maxcount = uap->bufsize / sizeof(struct statfs32);
 
 	if (sp32) {
 		sg = stackgap_init();
 		sp = stackgap_alloc(&sg, sizeof(struct statfs) * maxcount);
-		SCARG(uap, buf) = (struct statfs32 *)sp;
+		uap->buf = (struct statfs32 *)sp;
 	}
 	error = getfsstat(td, (struct getfsstat_args *) uap);
 	if (sp32 && !error) {
@@ -364,11 +364,11 @@
 	struct sigaltstack32 *p32, *op32, s32;
 	struct sigaltstack *p = NULL, *op = NULL, s;
 
-	p32 = SCARG(uap, ss);
+	p32 = uap->ss;
 	if (p32) {
 		sg = stackgap_init();
 		p = stackgap_alloc(&sg, sizeof(struct sigaltstack));
-		SCARG(uap, ss) = (struct sigaltstack32 *)p;
+		uap->ss = (struct sigaltstack32 *)p;
 		error = copyin(p32, &s32, sizeof(s32));
 		if (error)
 			return (error);
@@ -379,11 +379,11 @@
 		if (error)
 			return (error);
 	}
-	op32 = SCARG(uap, oss);
+	op32 = uap->oss;
 	if (op32) {
 		sg = stackgap_init();
 		op = stackgap_alloc(&sg, sizeof(struct sigaltstack));
-		SCARG(uap, oss) = (struct sigaltstack32 *)op;
+		uap->oss = (struct sigaltstack32 *)op;
 	}
 	error = sigaltstack(td, (struct sigaltstack_args *) uap);
 	if (error)
@@ -411,12 +411,12 @@
 	int count;
 
 	sg = stackgap_init();
-	CHECKALTEXIST(td, &sg, SCARG(uap, fname));
-	SCARG(&ap, fname) = SCARG(uap, fname);
+	CHECKALTEXIST(td, &sg, uap->fname);
+	ap.fname = uap->fname;
 
-	if (SCARG(uap, argv)) {
+	if (uap->argv) {
 		count = 0;
-		p32 = SCARG(uap, argv);
+		p32 = uap->argv;
 		do {
 			error = copyin(p32++, &arg, sizeof(arg));
 			if (error)
@@ -424,8 +424,8 @@
 			count++;
 		} while (arg != 0);
 		p = stackgap_alloc(&sg, count * sizeof(char *));
-		SCARG(&ap, argv) = p;
-		p32 = SCARG(uap, argv);
+		ap.argv = p;
+		p32 = uap->argv;
 		do {
 			error = copyin(p32++, &arg, sizeof(arg));
 			if (error)
@@ -433,9 +433,9 @@
 			*p++ = PTRIN(arg);
 		} while (arg != 0);
 	}
-	if (SCARG(uap, envv)) {
+	if (uap->envv) {
 		count = 0;
-		p32 = SCARG(uap, envv);
+		p32 = uap->envv;
 		do {
 			error = copyin(p32++, &arg, sizeof(arg));
 			if (error)
@@ -443,8 +443,8 @@
 			count++;
 		} while (arg != 0);
 		p = stackgap_alloc(&sg, count * sizeof(char *));
-		SCARG(&ap, envv) = p;
-		p32 = SCARG(uap, envv);
+		ap.envv = p;
+		p32 = uap->envv;
 		do {
 			error = copyin(p32++, &arg, sizeof(arg));
 			if (error)
@@ -489,10 +489,10 @@
 
 	if (fd != -1) {
 		struct pread_args r;
-		SCARG(&r, fd) = fd;
-		SCARG(&r, buf) = (void *) start;
-		SCARG(&r, nbyte) = end - start;
-		SCARG(&r, offset) = pos;
+		r.fd = fd;
+		r.buf = (void *) start;
+		r.nbyte = end - start;
+		r.offset = pos;
 		return (pread(td, &r));
 	} else {
 		while (start < end) {
@@ -507,13 +507,13 @@
 ia32_mmap(struct thread *td, struct ia32_mmap_args *uap)
 {
 	struct mmap_args ap;
-	vm_offset_t addr = (vm_offset_t) SCARG(uap, addr);
-	vm_size_t len	 = SCARG(uap, len);
-	int prot	 = SCARG(uap, prot);
-	int flags	 = SCARG(uap, flags);
-	int fd		 = SCARG(uap, fd);
-	off_t pos	 = (SCARG(uap, poslo)
-			    | ((off_t)SCARG(uap, poshi) << 32));
+	vm_offset_t addr = (vm_offset_t) uap->addr;
+	vm_size_t len	 = uap->len;
+	int prot	 = uap->prot;
+	int flags	 = uap->flags;
+	int fd		 = uap->fd;
+	off_t pos	 = (uap->poslo
+			    | ((off_t)uap->poshi << 32));
 	vm_size_t pageoff;
 	int error;
 
@@ -562,10 +562,10 @@
 					 prot, VM_PROT_ALL, 0);
 			if (rv != KERN_SUCCESS)
 				return (EINVAL);
-			SCARG(&r, fd) = fd;
-			SCARG(&r, buf) = (void *) start;
-			SCARG(&r, nbyte) = end - start;
-			SCARG(&r, offset) = pos;
+			r.fd = fd;
+			r.buf = (void *) start;
+			r.nbyte = end - start;
+			r.offset = pos;
 			error = pread(td, &r);
 			if (error)
 				return (error);
@@ -585,12 +585,12 @@
 		len = end - start;
 	}
 
-	SCARG(&ap, addr) = (void *) addr;
-	SCARG(&ap, len) = len;
-	SCARG(&ap, prot) = prot;
-	SCARG(&ap, flags) = flags;
-	SCARG(&ap, fd) = fd;
-	SCARG(&ap, pos) = pos;
+	ap.addr = (void *) addr;
+	ap.len = len;
+	ap.prot = prot;
+	ap.flags = flags;
+	ap.fd = fd;
+	ap.pos = pos;
 
 	return (mmap(td, &ap));
 }
@@ -608,11 +608,11 @@
 	struct itimerval32 *p32, *op32, s32;
 	struct itimerval *p = NULL, *op = NULL, s;
 
-	p32 = SCARG(uap, itv);
+	p32 = uap->itv;
 	if (p32) {
 		sg = stackgap_init();
 		p = stackgap_alloc(&sg, sizeof(struct itimerval));
-		SCARG(uap, itv) = (struct itimerval32 *)p;
+		uap->itv = (struct itimerval32 *)p;
 		error = copyin(p32, &s32, sizeof(s32));
 		if (error)
 			return (error);
@@ -622,11 +622,11 @@
 		if (error)
 			return (error);
 	}
-	op32 = SCARG(uap, oitv);
+	op32 = uap->oitv;
 	if (op32) {
 		sg = stackgap_init();
 		op = stackgap_alloc(&sg, sizeof(struct itimerval));
-		SCARG(uap, oitv) = (struct itimerval32 *)op;
+		uap->oitv = (struct itimerval32 *)op;
 	}
 	error = setitimer(td, (struct setitimer_args *) uap);
 	if (error)
@@ -650,11 +650,11 @@
 	struct timeval32 *p32, s32;
 	struct timeval *p = NULL, s;
 
-	p32 = SCARG(uap, tv);
+	p32 = uap->tv;
 	if (p32) {
 		sg = stackgap_init();
 		p = stackgap_alloc(&sg, sizeof(struct timeval));
-		SCARG(uap, tv) = (struct timeval32 *)p;
+		uap->tv = (struct timeval32 *)p;
 		error = copyin(p32, &s32, sizeof(s32));
 		if (error)
 			return (error);
@@ -678,11 +678,11 @@
 	struct timeval32 *p32, s32;
 	struct timeval *p = NULL, s;
 
-	p32 = SCARG(uap, tp);
+	p32 = uap->tp;
 	if (p32) {
 		sg = stackgap_init();
 		p = stackgap_alloc(&sg, sizeof(struct timeval));
-		SCARG(uap, tp) = (struct timeval32 *)p;
+		uap->tp = (struct timeval32 *)p;
 	}
 	error = gettimeofday(td, (struct gettimeofday_args *) uap);
 	if (error)
@@ -708,11 +708,11 @@
 	struct rusage32 *p32, s32;
 	struct rusage *p = NULL, s;
 
-	p32 = SCARG(uap, rusage);
+	p32 = uap->rusage;
 	if (p32) {
 		sg = stackgap_init();
 		p = stackgap_alloc(&sg, sizeof(struct rusage));
-		SCARG(uap, rusage) = (struct rusage32 *)p;
+		uap->rusage = (struct rusage32 *)p;
 	}
 	error = getrusage(td, (struct getrusage_args *) uap);
 	if (error)
@@ -763,28 +763,28 @@
 
 	sg = stackgap_init();
 
-	if (SCARG(uap, iovcnt) > (STACKGAPLEN / sizeof (struct iovec)))
+	if (uap->iovcnt > (STACKGAPLEN / sizeof (struct iovec)))
 		return (EINVAL);
 
-	osize = SCARG(uap, iovcnt) * sizeof (struct iovec32);
-	nsize = SCARG(uap, iovcnt) * sizeof (struct iovec);
+	osize = uap->iovcnt * sizeof (struct iovec32);
+	nsize = uap->iovcnt * sizeof (struct iovec);
 
 	oio = malloc(osize, M_TEMP, M_WAITOK);
 	nio = malloc(nsize, M_TEMP, M_WAITOK);
 
 	error = 0;
-	if ((error = copyin(SCARG(uap, iovp), oio, osize)))
+	if ((error = copyin(uap->iovp, oio, osize)))
 		goto punt;
-	for (i = 0; i < SCARG(uap, iovcnt); i++) {
+	for (i = 0; i < uap->iovcnt; i++) {
 		nio[i].iov_base = PTRIN(oio[i].iov_base);
 		nio[i].iov_len = oio[i].iov_len;
 	}
 
-	SCARG(&a, fd) = SCARG(uap, fd);
-	SCARG(&a, iovp) = stackgap_alloc(&sg, nsize);
-	SCARG(&a, iovcnt) = SCARG(uap, iovcnt);
+	a.fd = uap->fd;
+	a.iovp = stackgap_alloc(&sg, nsize);
+	a.iovcnt = uap->iovcnt;
 
-	if ((error = copyout(nio, (caddr_t)SCARG(&a, iovp), nsize)))
+	if ((error = copyout(nio, (caddr_t)a.iovp, nsize)))
 		goto punt;
 	error = readv(td, &a);
 
@@ -809,28 +809,28 @@
 
 	sg = stackgap_init();
 
-	if (SCARG(uap, iovcnt) > (STACKGAPLEN / sizeof (struct iovec)))
+	if (uap->iovcnt > (STACKGAPLEN / sizeof (struct iovec)))
 		return (EINVAL);
 
-	osize = SCARG(uap, iovcnt) * sizeof (struct iovec32);
-	nsize = SCARG(uap, iovcnt) * sizeof (struct iovec);
+	osize = uap->iovcnt * sizeof (struct iovec32);
+	nsize = uap->iovcnt * sizeof (struct iovec);
 
 	oio = malloc(osize, M_TEMP, M_WAITOK);
 	nio = malloc(nsize, M_TEMP, M_WAITOK);
 
 	error = 0;
-	if ((error = copyin(SCARG(uap, iovp), oio, osize)))
+	if ((error = copyin(uap->iovp, oio, osize)))
 		goto punt;
-	for (i = 0; i < SCARG(uap, iovcnt); i++) {
+	for (i = 0; i < uap->iovcnt; i++) {
 		nio[i].iov_base = PTRIN(oio[i].iov_base);
 		nio[i].iov_len = oio[i].iov_len;
 	}
 
-	SCARG(&a, fd) = SCARG(uap, fd);
-	SCARG(&a, iovp) = stackgap_alloc(&sg, nsize);
-	SCARG(&a, iovcnt) = SCARG(uap, iovcnt);
+	a.fd = uap->fd;
+	a.iovp = stackgap_alloc(&sg, nsize);
+	a.iovcnt = uap->iovcnt;
 
-	if ((error = copyout(nio, (caddr_t)SCARG(&a, iovp), nsize)))
+	if ((error = copyout(nio, (caddr_t)a.iovp, nsize)))
 		goto punt;
 	error = writev(td, &a);
 
@@ -848,11 +848,11 @@
 	struct timeval32 *p32, s32;
 	struct timeval *p = NULL, s;
 
-	p32 = SCARG(uap, tv);
+	p32 = uap->tv;
 	if (p32) {
 		sg = stackgap_init();
 		p = stackgap_alloc(&sg, sizeof(struct timeval));
-		SCARG(uap, tv) = (struct timeval32 *)p;
+		uap->tv = (struct timeval32 *)p;
 		error = copyin(p32, &s32, sizeof(s32));
 		if (error)
 			return (error);
@@ -873,11 +873,11 @@
 	struct timeval32 *p32, s32[2];
 	struct timeval *p = NULL, s[2];
 
-	p32 = SCARG(uap, tptr);
+	p32 = uap->tptr;
 	if (p32) {
 		sg = stackgap_init();
 		p = stackgap_alloc(&sg, 2*sizeof(struct timeval));
-		SCARG(uap, tptr) = (struct timeval32 *)p;
+		uap->tptr = (struct timeval32 *)p;
 		error = copyin(p32, s32, sizeof(s32));
 		if (error)
 			return (error);
@@ -900,11 +900,11 @@
 	struct timeval32 *p32, *op32, s32;
 	struct timeval *p = NULL, *op = NULL, s;
 
-	p32 = SCARG(uap, delta);
+	p32 = uap->delta;
 	if (p32) {
 		sg = stackgap_init();
 		p = stackgap_alloc(&sg, sizeof(struct timeval));
-		SCARG(uap, delta) = (struct timeval32 *)p;
+		uap->delta = (struct timeval32 *)p;
 		error = copyin(p32, &s32, sizeof(s32));
 		if (error)
 			return (error);
@@ -914,11 +914,11 @@
 		if (error)
 			return (error);
 	}
-	op32 = SCARG(uap, olddelta);
+	op32 = uap->olddelta;
 	if (op32) {
 		sg = stackgap_init();
 		op = stackgap_alloc(&sg, sizeof(struct timeval));
-		SCARG(uap, olddelta) = (struct timeval32 *)op;
+		uap->olddelta = (struct timeval32 *)op;
 	}
 	error = utimes(td, (struct utimes_args *) uap);
 	if (error)
@@ -942,11 +942,11 @@
 	struct statfs32 *p32, s32;
 	struct statfs *p = NULL, s;
 
-	p32 = SCARG(uap, buf);
+	p32 = uap->buf;
 	if (p32) {
 		sg = stackgap_init();
 		p = stackgap_alloc(&sg, sizeof(struct statfs));
-		SCARG(uap, buf) = (struct statfs32 *)p;
+		uap->buf = (struct statfs32 *)p;
 	}
 	error = statfs(td, (struct statfs_args *) uap);
 	if (error)
@@ -969,11 +969,11 @@
 	struct statfs32 *p32, s32;
 	struct statfs *p = NULL, s;
 
-	p32 = SCARG(uap, buf);
+	p32 = uap->buf;
 	if (p32) {
 		sg = stackgap_init();
 		p = stackgap_alloc(&sg, sizeof(struct statfs));
-		SCARG(uap, buf) = (struct statfs32 *)p;
+		uap->buf = (struct statfs32 *)p;
 	}
 	error = fstatfs(td, (struct fstatfs_args *) uap);
 	if (error)
@@ -1020,11 +1020,11 @@
 {
 	struct pread_args ap;
 
-	SCARG(&ap, fd) = SCARG(uap, fd);
-	SCARG(&ap, buf) = SCARG(uap, buf);
-	SCARG(&ap, nbyte) = SCARG(uap, nbyte);
-	SCARG(&ap, offset) = (SCARG(uap, offsetlo)
-			      | ((off_t)SCARG(uap, offsethi) << 32));
+	ap.fd = uap->fd;
+	ap.buf = uap->buf;
+	ap.nbyte = uap->nbyte;
+	ap.offset = (uap->offsetlo
+			      | ((off_t)uap->offsethi << 32));
 	return (pread(td, &ap));
 }
 
@@ -1033,11 +1033,11 @@
 {
 	struct pwrite_args ap;
 
-	SCARG(&ap, fd) = SCARG(uap, fd);
-	SCARG(&ap, buf) = SCARG(uap, buf);
-	SCARG(&ap, nbyte) = SCARG(uap, nbyte);
-	SCARG(&ap, offset) = (SCARG(uap, offsetlo)
-			      | ((off_t)SCARG(uap, offsethi) << 32));
+	ap.fd = uap->fd;
+	ap.buf = uap->buf;
+	ap.nbyte = uap->nbyte;
+	ap.offset = (uap->offsetlo
+			      | ((off_t)uap->offsethi << 32));
 	return (pwrite(td, &ap));
 }
 
@@ -1048,10 +1048,10 @@
 	struct lseek_args ap;
 	off_t pos;
 
-	SCARG(&ap, fd) = SCARG(uap, fd);
-	SCARG(&ap, offset) = (SCARG(uap, offsetlo)
-			      | ((off_t)SCARG(uap, offsethi) << 32));
-	SCARG(&ap, whence) = SCARG(uap, whence);
+	ap.fd = uap->fd;
+	ap.offset = (uap->offsetlo
+			      | ((off_t)uap->offsethi << 32));
+	ap.whence = uap->whence;
 	error = lseek(td, &ap);
 	/* Expand the quad return into two parts for eax and edx */
 	pos = *(off_t *)(td->td_retval);
@@ -1065,9 +1065,9 @@
 {
 	struct truncate_args ap;
 
-	SCARG(&ap, path) = SCARG(uap, path);
-	SCARG(&ap, length) = (SCARG(uap, lengthlo)
-			      | ((off_t)SCARG(uap, lengthhi) << 32));
+	ap.path = uap->path;
+	ap.length = (uap->lengthlo
+			      | ((off_t)uap->lengthhi << 32));
 	return (truncate(td, &ap));
 }
 
@@ -1076,9 +1076,9 @@
 {
 	struct ftruncate_args ap;
 
-	SCARG(&ap, fd) = SCARG(uap, fd);
-	SCARG(&ap, length) = (SCARG(uap, lengthlo)
-			      | ((off_t)SCARG(uap, lengthhi) << 32));
+	ap.fd = uap->fd;
+	ap.length = (uap->lengthlo
+			      | ((off_t)uap->lengthhi << 32));
 	return (ftruncate(td, &ap));
 }
 
@@ -1089,14 +1089,14 @@
 {
 	struct freebsd4_sendfile_args ap;
 
-	SCARG(&ap, fd) = SCARG(uap, fd);
-	SCARG(&ap, s) = SCARG(uap, s);
-	SCARG(&ap, offset) = (SCARG(uap, offsetlo)
-			      | ((off_t)SCARG(uap, offsethi) << 32));
-	SCARG(&ap, nbytes) = SCARG(uap, nbytes);	/* XXX check */
-	SCARG(&ap, hdtr) = SCARG(uap, hdtr);		/* XXX check */
-	SCARG(&ap, sbytes) = SCARG(uap, sbytes);	/* XXX FIXME!! */
-	SCARG(&ap, flags) = SCARG(uap, flags);
+	ap.fd = uap->fd;
+	ap.s = uap->s;
+	ap.offset = (uap->offsetlo
+			      | ((off_t)uap->offsethi << 32));
+	ap.nbytes = uap->nbytes;	/* XXX check */
+	ap.hdtr = uap->hdtr;		/* XXX check */
+	ap.sbytes = uap->sbytes;	/* XXX FIXME!! */
+	ap.flags = uap->flags;
 	return (freebsd4_sendfile(td, &ap));
 }
 #endif
@@ -1106,14 +1106,14 @@
 {
 	struct sendfile_args ap;
 
-	SCARG(&ap, fd) = SCARG(uap, fd);
-	SCARG(&ap, s) = SCARG(uap, s);
-	SCARG(&ap, offset) = (SCARG(uap, offsetlo)
-			      | ((off_t)SCARG(uap, offsethi) << 32));
-	SCARG(&ap, nbytes) = SCARG(uap, nbytes);	/* XXX check */
-	SCARG(&ap, hdtr) = SCARG(uap, hdtr);		/* XXX check */
-	SCARG(&ap, sbytes) = SCARG(uap, sbytes);	/* XXX FIXME!! */
-	SCARG(&ap, flags) = SCARG(uap, flags);
+	ap.fd = uap->fd;
+	ap.s = uap->s;
+	ap.offset = (uap->offsetlo
+			      | ((off_t)uap->offsethi << 32));
+	ap.nbytes = uap->nbytes;	/* XXX check */
+	ap.hdtr = uap->hdtr;		/* XXX check */
+	ap.sbytes = uap->sbytes;	/* XXX FIXME!! */
+	ap.flags = uap->flags;
 	return (sendfile(td, &ap));
 }
 
@@ -1163,11 +1163,11 @@
 	struct stat32 *p32, s32;
 	struct stat *p = NULL, s;
 
-	p32 = SCARG(uap, ub);
+	p32 = uap->ub;
 	if (p32) {
 		sg = stackgap_init();
 		p = stackgap_alloc(&sg, sizeof(struct stat));
-		SCARG(uap, ub) = (struct stat32 *)p;
+		uap->ub = (struct stat32 *)p;
 	}
 	error = stat(td, (struct stat_args *) uap);
 	if (error)
@@ -1190,11 +1190,11 @@
 	struct stat32 *p32, s32;
 	struct stat *p = NULL, s;
 
-	p32 = SCARG(uap, ub);
+	p32 = uap->ub;
 	if (p32) {
 		sg = stackgap_init();
 		p = stackgap_alloc(&sg, sizeof(struct stat));
-		SCARG(uap, ub) = (struct stat32 *)p;
+		uap->ub = (struct stat32 *)p;
 	}
 	error = fstat(td, (struct fstat_args *) uap);
 	if (error)
@@ -1217,11 +1217,11 @@
 	struct stat32 *p32, s32;
 	struct stat *p = NULL, s;
 
-	p32 = SCARG(uap, ub);
+	p32 = uap->ub;
 	if (p32) {
 		sg = stackgap_init();
 		p = stackgap_alloc(&sg, sizeof(struct stat));
-		SCARG(uap, ub) = (struct stat32 *)p;
+		uap->ub = (struct stat32 *)p;
 	}
 	error = lstat(td, (struct lstat_args *) uap);
 	if (error)
@@ -1285,11 +1285,11 @@
 	struct sigaction32 *p32, *op32, s32;
 	struct sigaction *p = NULL, *op = NULL, s;
 
-	p32 = SCARG(uap, act);
+	p32 = uap->act;
 	if (p32) {
 		sg = stackgap_init();
 		p = stackgap_alloc(&sg, sizeof(struct sigaction));
-		SCARG(uap, act) = (struct sigaction32 *)p;
+		uap->act = (struct sigaction32 *)p;
 		error = copyin(p32, &s32, sizeof(s32));
 		if (error)
 			return (error);
@@ -1300,11 +1300,11 @@
 		if (error)
 			return (error);
 	}
-	op32 = SCARG(uap, oact);
+	op32 = uap->oact;
 	if (op32) {
 		sg = stackgap_init();
 		op = stackgap_alloc(&sg, sizeof(struct sigaction));
-		SCARG(uap, oact) = (struct sigaction32 *)op;
+		uap->oact = (struct sigaction32 *)op;
 	}
 	error = sigaction(td, (struct sigaction_args *) uap);
 	if (error)
@@ -1331,11 +1331,11 @@
 	struct yyy32 *p32, s32;
 	struct yyy *p = NULL, s;
 
-	p32 = SCARG(uap, zzz);
+	p32 = uap->zzz;
 	if (p32) {
 		sg = stackgap_init();
 		p = stackgap_alloc(&sg, sizeof(struct yyy));
-		SCARG(uap, zzz) = (struct yyy32 *)p;
+		uap->zzz = (struct yyy32 *)p;
 		error = copyin(p32, &s32, sizeof(s32));
 		if (error)
 			return (error);
Index: ia64/ia32/ia32_util.h
===================================================================
RCS file: /home/ncvs/src/sys/ia64/ia32/ia32_util.h,v
retrieving revision 1.1
diff -u -r1.1 ia32_util.h
--- ia64/ia32/ia32_util.h	20 Jul 2002 02:56:10 -0000	1.1
+++ ia64/ia32/ia32_util.h	12 Dec 2002 03:14:38 -0000
@@ -37,11 +37,6 @@
 #include <sys/sysent.h>
 #include <sys/cdefs.h>
 
-
-#ifndef	SCARG
-#define	SCARG(p, x)  (p)->x
-#endif
-
 struct ia32_ps_strings {
 	u_int32_t ps_argvstr;	/* first of 0 or more argument strings */
 	int	ps_nargvstr;	/* the number of argument strings */
Index: ia64/ia64/sys_machdep.c
===================================================================
RCS file: /home/ncvs/src/sys/ia64/ia64/sys_machdep.c,v
retrieving revision 1.2
diff -u -r1.2 sys_machdep.c
--- ia64/ia64/sys_machdep.c	12 Sep 2001 08:37:40 -0000	1.2
+++ ia64/ia64/sys_machdep.c	12 Dec 2002 03:14:38 -0000
@@ -70,7 +70,7 @@
 {
 	int error = 0;
 
-	switch(SCARG(uap,op)) {
+	switch(uap->op) {
 	default:
 		error = EINVAL;
 		break;
Index: kern/kern_acct.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/kern_acct.c,v
retrieving revision 1.55
diff -u -r1.55 kern_acct.c
--- kern/kern_acct.c	26 Nov 2002 18:04:12 -0000	1.55
+++ kern/kern_acct.c	12 Dec 2002 03:15:20 -0000
@@ -139,8 +139,8 @@
 	 * If accounting is to be started to a file, open that file for
 	 * appending and make sure it's a 'normal'.
 	 */
-	if (SCARG(uap, path) != NULL) {
-		NDINIT(&nd, LOOKUP, NOFOLLOW, UIO_USERSPACE, SCARG(uap, path),
+	if (uap->path != NULL) {
+		NDINIT(&nd, LOOKUP, NOFOLLOW, UIO_USERSPACE, uap->path,
 		       td);
 		flags = FWRITE | O_APPEND;
 		error = vn_open(&nd, &flags, 0);
@@ -187,7 +187,7 @@
 		crfree(acctcred != NOCRED ? acctcred : savacctcred);
 		acctcred = savacctcred = NOCRED;
 	}
-	if (SCARG(uap, path) == NULL) {
+	if (uap->path == NULL) {
 		mtx_unlock(&acct_mtx);
 		goto done2;
 	}
Index: kern/kern_acl.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/kern_acl.c,v
retrieving revision 1.32
diff -u -r1.32 kern_acl.c
--- kern/kern_acl.c	1 Aug 2002 01:04:16 -0000	1.32
+++ kern/kern_acl.c	12 Dec 2002 03:15:20 -0000
@@ -689,11 +689,11 @@
 	int error;
 
 	mtx_lock(&Giant);
-	NDINIT(&nd, LOOKUP, FOLLOW, UIO_USERSPACE, SCARG(uap, path), td);
+	NDINIT(&nd, LOOKUP, FOLLOW, UIO_USERSPACE, uap->path, td);
 	error = namei(&nd);
 	if (error == 0) {
-		error = vacl_get_acl(td, nd.ni_vp, SCARG(uap, type), 
-			    SCARG(uap, aclp));
+		error = vacl_get_acl(td, nd.ni_vp, uap->type, 
+			    uap->aclp);
 		NDFREE(&nd, 0);
 	}
 	mtx_unlock(&Giant);
@@ -712,11 +712,11 @@
 	int error;
 
 	mtx_lock(&Giant);
-	NDINIT(&nd, LOOKUP, FOLLOW, UIO_USERSPACE, SCARG(uap, path), td);
+	NDINIT(&nd, LOOKUP, FOLLOW, UIO_USERSPACE, uap->path, td);
 	error = namei(&nd);
 	if (error == 0) {
-		error = vacl_set_acl(td, nd.ni_vp, SCARG(uap, type),
-			    SCARG(uap, aclp));
+		error = vacl_set_acl(td, nd.ni_vp, uap->type,
+			    uap->aclp);
 		NDFREE(&nd, 0);
 	}
 	mtx_unlock(&Giant);
@@ -735,10 +735,10 @@
 	int error;
 
 	mtx_lock(&Giant);
-	error = getvnode(td->td_proc->p_fd, SCARG(uap, filedes), &fp);
+	error = getvnode(td->td_proc->p_fd, uap->filedes, &fp);
 	if (error == 0) {
 		error = vacl_get_acl(td, (struct vnode *)fp->f_data,
-			    SCARG(uap, type), SCARG(uap, aclp));
+			    uap->type, uap->aclp);
 		fdrop(fp, td);
 	}
 	mtx_unlock(&Giant);
@@ -757,10 +757,10 @@
 	int error;
 
 	mtx_lock(&Giant);
-	error = getvnode(td->td_proc->p_fd, SCARG(uap, filedes), &fp);
+	error = getvnode(td->td_proc->p_fd, uap->filedes, &fp);
 	if (error == 0) {
 		error = vacl_set_acl(td, (struct vnode *)fp->f_data,
-			    SCARG(uap, type), SCARG(uap, aclp));
+			    uap->type, uap->aclp);
 		fdrop(fp, td);
 	}
 	mtx_unlock(&Giant);
@@ -779,10 +779,10 @@
 	int error;
 
 	mtx_lock(&Giant);
-	NDINIT(&nd, LOOKUP, FOLLOW, UIO_USERSPACE, SCARG(uap, path), td);
+	NDINIT(&nd, LOOKUP, FOLLOW, UIO_USERSPACE, uap->path, td);
 	error = namei(&nd);
 	if (error == 0) {
-		error = vacl_delete(td, nd.ni_vp, SCARG(uap, type));
+		error = vacl_delete(td, nd.ni_vp, uap->type);
 		NDFREE(&nd, 0);
 	}
 	mtx_unlock(&Giant);
@@ -801,10 +801,10 @@
 	int error;
 
 	mtx_lock(&Giant);
-	error = getvnode(td->td_proc->p_fd, SCARG(uap, filedes), &fp);
+	error = getvnode(td->td_proc->p_fd, uap->filedes, &fp);
 	if (error == 0) {
 		error = vacl_delete(td, (struct vnode *)fp->f_data, 
-			    SCARG(uap, type));
+			    uap->type);
 		fdrop(fp, td);
 	}
 	mtx_unlock(&Giant);
@@ -823,11 +823,11 @@
 	int	error;
 
 	mtx_lock(&Giant);
-	NDINIT(&nd, LOOKUP, FOLLOW, UIO_USERSPACE, SCARG(uap, path), td);
+	NDINIT(&nd, LOOKUP, FOLLOW, UIO_USERSPACE, uap->path, td);
 	error = namei(&nd);
 	if (error == 0) {
-		error = vacl_aclcheck(td, nd.ni_vp, SCARG(uap, type),
-			    SCARG(uap, aclp));
+		error = vacl_aclcheck(td, nd.ni_vp, uap->type,
+			    uap->aclp);
 		NDFREE(&nd, 0);
 	}
 	mtx_unlock(&Giant);
@@ -846,10 +846,10 @@
 	int error;
 
 	mtx_lock(&Giant);
-	error = getvnode(td->td_proc->p_fd, SCARG(uap, filedes), &fp);
+	error = getvnode(td->td_proc->p_fd, uap->filedes, &fp);
 	if (error == 0) {
 		error = vacl_aclcheck(td, (struct vnode *)fp->f_data,
-			    SCARG(uap, type), SCARG(uap, aclp));
+			    uap->type, uap->aclp);
 		fdrop(fp, td);
 	}
 	mtx_unlock(&Giant);
Index: kern/kern_environment.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/kern_environment.c,v
retrieving revision 1.26
diff -u -r1.26 kern_environment.c
--- kern/kern_environment.c	1 Nov 2002 20:46:53 -0000	1.26
+++ kern/kern_environment.c	12 Dec 2002 03:15:21 -0000
@@ -92,7 +92,7 @@
 	KASSERT(dynamic_kenv, ("kenv: dynamic_kenv = 0"));
 
 	error = 0;
-	if (SCARG(uap, what) == KENV_DUMP) {
+	if (uap->what == KENV_DUMP) {
 #ifdef MAC
 		error = mac_check_kenv_dump(td->td_ucred);
 		if (error)
@@ -100,7 +100,7 @@
 #endif
 		len = 0;
 		/* Return the size if called with a NULL buffer */
-		if (SCARG(uap, value) == NULL) {
+		if (uap->value == NULL) {
 			sx_slock(&kenv_lock);
 			for (i = 0; kenvp[i] != NULL; i++)
 				len += strlen(kenvp[i]) + 1;
@@ -110,9 +110,9 @@
 		}
 		done = 0;
 		sx_slock(&kenv_lock);
-		for (i = 0; kenvp[i] != NULL && done < SCARG(uap, len); i++) {
-			len = min(strlen(kenvp[i]) + 1, SCARG(uap, len) - done);
-			error = copyout(kenvp[i], SCARG(uap, value) + done,
+		for (i = 0; kenvp[i] != NULL && done < uap->len; i++) {
+			len = min(strlen(kenvp[i]) + 1, uap->len - done);
+			error = copyout(kenvp[i], uap->value + done,
 			    len);
 			if (error) {
 				sx_sunlock(&kenv_lock);
@@ -124,8 +124,8 @@
 		return (0);
 	}
 
-	if ((SCARG(uap, what) == KENV_SET) ||
-	    (SCARG(uap, what) == KENV_UNSET)) {
+	if ((uap->what == KENV_SET) ||
+	    (uap->what == KENV_UNSET)) {
 		error = suser(td);
 		if (error)
 			return (error);
@@ -133,11 +133,11 @@
 
 	name = malloc(KENV_MNAMELEN, M_TEMP, M_WAITOK);
 
-	error = copyinstr(SCARG(uap, name), name, KENV_MNAMELEN, NULL);
+	error = copyinstr(uap->name, name, KENV_MNAMELEN, NULL);
 	if (error)
 		goto done;
 
-	switch (SCARG(uap, what)) {
+	switch (uap->what) {
 	case KENV_GET:
 #ifdef MAC
 		error = mac_check_kenv_get(td->td_ucred, name);
@@ -150,16 +150,16 @@
 			goto done;
 		}
 		len = strlen(value) + 1;
-		if (len > SCARG(uap, len))
-			len = SCARG(uap, len);
-		error = copyout(value, SCARG(uap, value), len);
+		if (len > uap->len)
+			len = uap->len;
+		error = copyout(value, uap->value, len);
 		freeenv(value);
 		if (error)
 			goto done;
 		td->td_retval[0] = len;
 		break;
 	case KENV_SET:
-		len = SCARG(uap, len);
+		len = uap->len;
 		if (len < 1) {
 			error = EINVAL;
 			goto done;
@@ -167,7 +167,7 @@
 		if (len > KENV_MVALLEN)
 			len = KENV_MVALLEN;
 		value = malloc(len, M_TEMP, M_WAITOK);
-		error = copyinstr(SCARG(uap, value), value, len, NULL);
+		error = copyinstr(uap->value, value, len, NULL);
 		if (error) {
 			free(value, M_TEMP);
 			goto done;
Index: kern/kern_linker.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/kern_linker.c,v
retrieving revision 1.97
diff -u -r1.97 kern_linker.c
--- kern/kern_linker.c	19 Nov 2002 22:12:42 -0000	1.97
+++ kern/kern_linker.c	12 Dec 2002 03:15:22 -0000
@@ -754,7 +754,7 @@
 		goto out;
 
 	pathname = malloc(MAXPATHLEN, M_TEMP, M_WAITOK);
-	if ((error = copyinstr(SCARG(uap, file), pathname, MAXPATHLEN,
+	if ((error = copyinstr(uap->file, pathname, MAXPATHLEN,
 	    NULL)) != 0)
 		goto out;
 
@@ -800,7 +800,7 @@
 	if ((error = suser(td)) != 0)
 		goto out;
 
-	lf = linker_find_file_by_id(SCARG(uap, fileid));
+	lf = linker_find_file_by_id(uap->fileid);
 	if (lf) {
 		KLD_DPF(FILE, ("kldunload: lf->userrefs=%d\n", lf->userrefs));
 		if (lf->userrefs == 0) {
@@ -841,7 +841,7 @@
 	td->td_retval[0] = -1;
 
 	pathname = malloc(MAXPATHLEN, M_TEMP, M_WAITOK);
-	if ((error = copyinstr(SCARG(uap, file), pathname, MAXPATHLEN,
+	if ((error = copyinstr(uap->file, pathname, MAXPATHLEN,
 	    NULL)) != 0)
 		goto out;
 
@@ -875,7 +875,7 @@
 
 	mtx_lock(&Giant);
 
-	if (SCARG(uap, fileid) == 0) {
+	if (uap->fileid == 0) {
 		mtx_lock(&kld_mtx);
 		if (TAILQ_FIRST(&linker_files))
 			td->td_retval[0] = TAILQ_FIRST(&linker_files)->id;
@@ -884,7 +884,7 @@
 		mtx_unlock(&kld_mtx);
 		goto out;
 	}
-	lf = linker_find_file_by_id(SCARG(uap, fileid));
+	lf = linker_find_file_by_id(uap->fileid);
 	if (lf) {
 		if (TAILQ_NEXT(lf, link))
 			td->td_retval[0] = TAILQ_NEXT(lf, link)->id;
@@ -916,12 +916,12 @@
 
 	mtx_lock(&Giant);
 
-	lf = linker_find_file_by_id(SCARG(uap, fileid));
+	lf = linker_find_file_by_id(uap->fileid);
 	if (lf == NULL) {
 		error = ENOENT;
 		goto out;
 	}
-	stat = SCARG(uap, stat);
+	stat = uap->stat;
 
 	/*
 	 * Check the version of the user's structure.
@@ -970,7 +970,7 @@
 #endif
 
 	mtx_lock(&Giant);
-	lf = linker_find_file_by_id(SCARG(uap, fileid));
+	lf = linker_find_file_by_id(uap->fileid);
 	if (lf) {
 		MOD_SLOCK;
 		mp = TAILQ_FIRST(&lf->modules);
@@ -1006,18 +1006,18 @@
 
 	mtx_lock(&Giant);
 
-	if ((error = copyin(SCARG(uap, data), &lookup, sizeof(lookup))) != 0)
+	if ((error = copyin(uap->data, &lookup, sizeof(lookup))) != 0)
 		goto out;
 	if (lookup.version != sizeof(lookup) ||
-	    SCARG(uap, cmd) != KLDSYM_LOOKUP) {
+	    uap->cmd != KLDSYM_LOOKUP) {
 		error = EINVAL;
 		goto out;
 	}
 	symstr = malloc(MAXPATHLEN, M_TEMP, M_WAITOK);
 	if ((error = copyinstr(lookup.symname, symstr, MAXPATHLEN, NULL)) != 0)
 		goto out;
-	if (SCARG(uap, fileid) != 0) {
-		lf = linker_find_file_by_id(SCARG(uap, fileid));
+	if (uap->fileid != 0) {
+		lf = linker_find_file_by_id(uap->fileid);
 		if (lf == NULL) {
 			error = ENOENT;
 			goto out;
@@ -1026,7 +1026,7 @@
 		    LINKER_SYMBOL_VALUES(lf, sym, &symval) == 0) {
 			lookup.symvalue = (uintptr_t) symval.value;
 			lookup.symsize = symval.size;
-			error = copyout(&lookup, SCARG(uap, data),
+			error = copyout(&lookup, uap->data,
 			    sizeof(lookup));
 		} else
 			error = ENOENT;
@@ -1037,7 +1037,7 @@
 			    LINKER_SYMBOL_VALUES(lf, sym, &symval) == 0) {
 				lookup.symvalue = (uintptr_t)symval.value;
 				lookup.symsize = symval.size;
-				error = copyout(&lookup, SCARG(uap, data),
+				error = copyout(&lookup, uap->data,
 				    sizeof(lookup));
 				break;
 			}
